%Run tintern in a loop and find optimum h such that b is as close to 5*a/7
%as possible ...

function find_best_h
R_over_r = 3/4;
h = linspace(0.6,0.7,1000);
for n=1:length(h)
    f(n) = tintern( h(n),R_over_r ,0 ) - 5/7;
    disp([ 'h(',num2str(n),') = ',num2str(h(n)),', f(',num2str(n),') = ',num2str(f(n)) ] );
end
hroot = rootfindergeneral(h,f);
disp(' ');
disp(['Best h = ',num2str(hroot,10) ]); figure; axes; set(gca,'fontsize',18);
plot( h, f,'linewidth',2 ); xlabel('h'); ylabel( 'tintern(h,0) - 5/7' ); title(['Best h = ',num2str(hroot) ]);
hold on; xlimits = get(gca,'xlim'); ylimits = get(gca,'ylim'); grid on;
plot( [hroot,hroot],ylimits ); plot( xlimits,[0,0] );
print( gcf,'best h.png','-dpng','-r300' ); close(gcf);

%Now run optimum tintern
b = tintern(hroot,R_over_r , 1);
disp( ['b - 5/7 = ',num2str(b-5/7)] );

%%

%Find root(s) of function f(x)
function xroot = rootfindergeneral(x,f)
xroot = [];
for n=1:length(x)-1
    if ( ( f(n+1)>=0 ) && ( f(n) <=0 ) ) || ( ( f(n+1)<=0 ) && ( f(n) >=0 ) )
        xroot = [xroot,0.5*( x(n) + x(n+1) )];
    end
end

%End of code
